package eknife.config;

import java.io.File;

public final class Config extends misc.Config
{
	/********************************************************************************************************************************/
	/************************************************************ STATIC ************************************************************/
	/********************************************************************************************************************************/
	private static final Config config = new Config();

	public static Config getConfig()
	{
		return Config.config;
	}

	/********************************************************************************************************************************/
	/************************************************************ OBJECT ************************************************************/
	/********************************************************************************************************************************/
	private final String scriptsPath;

	/****************************************************************/
	/************************* Constructor **************************/
	/****************************************************************/
	private Config()
	{
		this.scriptsPath = super.rootPath + "script" + File.separator;
	}

	/****************************************************************/
	/**************************** Paths *****************************/
	/****************************************************************/
	public String getScriptsPath()
	{
		return this.scriptsPath;
	}

	/****************************************************************/
	/**************************** Files *****************************/
	/****************************************************************/
	public File getScriptsFile()
	{
		return new File(this.getScriptsPath());
	}
}